/*
   (C) 2004 by Argonne National Laboratory.
       See COPYRIGHT in top-level directory.
*/
#include "collchk.h" 

int MPI_Bcast(void* buff, int cnt, MPI_Datatype dt, int root, MPI_Comm comm)
{
    int g2g = 1;
    char call[25];

    sprintf(call, "BCAST");

    /* Check if init has been called */
    g2g = CollChk_is_init();

    if(g2g) {
        /* check call consistancy */
        CollChk_same_call(comm, call);
        /* check root consistancy */
        CollChk_same_root(comm, root, call);

        /* check datatype signature consistancy */
        CollChk_same_dtype(comm, cnt, dt, call);

        /* make the call */
        return (PMPI_Bcast(buff, cnt, dt, root, comm));
    }
    else {
        /* init not called */
        return CollChk_err_han("MPI_Init() has not been called!",
                               COLLCHK_ERR_NOT_INIT, call, comm);
    }
}

